#include <bits/stdc++.h>
using namespace std;

void simulate(vector <vector <char>>& v, char direction) {
    int n = v.size(), m = v[0].size();

    if (direction == 'L') {
        for (int i = 0; i < n; i++) {
            int br = 0;

            for (int j = 0; j < m; j++) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[i][br]);
                    br++;
                }
            }
        }
    }

    if (direction == 'R') {
        for (int i = 0; i < n; i++) {
            int br = m - 1;

            for (int j = m - 1; j >= 0; j--) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[i][br]);
                    br--;
                }
            }
        }
    }

    if (direction == 'U') {
        for (int j = 0; j < m; j++) {
            int br = 0;

            for (int i = 0; i < n; i++) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[br][j]);
                    br++;
                }
            }
        }
    }

    if (direction == 'D') {
        for (int j = 0; j < m; j++) {
            int br = n - 1;

            for (int i = n - 1; i >= 0; i--) {
                if (v[i][j] != '.') {
                    swap(v[i][j], v[br][j]);
                    br--;
                }
            }
        }
    }
}

void output(vector <vector <char>>& v) {
    int n = v.size(), m = v[0].size();

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) cout << v[i][j];
        cout << '\n';
    }
}


/**

L - 0
R - 1
U - 0
D - 1

*/

int ds[256], type[256];


string optimize(string s) {
    string next;

    for (int i = 0; i < s.size(); i++) {
        if (i + 1 == s.size() || type[s[i]] != type[s[i + 1]]) {
            next.push_back(s[i]);
        }
    }

    if (next.size() == 1) return next;

    s = next;
    next.clear();

    next.push_back(s[0]);
    next.push_back(s[1]);

    int vertical, horizontal;

    if (type[s[0]] == 0) {
        vertical = ds[s[0]];
        horizontal = ds[s[1]];
    } else {
        vertical = ds[s[1]];
        horizontal = ds[s[0]];
    }

    for (int i = 2; i < s.size(); i++) {
        if (type[s[i]] == 0) {
            if (vertical == ds[s[i]]) continue;

            if (next.size() && type[next.back()] == type[s[i]]) {
                next.pop_back();

                if (next.size() < 2) next.push_back(s[i]);
            } else next.push_back(s[i]);

            vertical = ds[s[i]];
        } else {
            if (horizontal == ds[s[i]]) continue;

            if (next.size() && type[next.back()] == type[s[i]]) {
                next.pop_back();

                if (next.size() < 2) next.push_back(s[i]);
            } else next.push_back(s[i]);

            horizontal = ds[s[i]];
        }
    }

    return next;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;


    ds['R'] = 1;
    ds['D'] = 1;
    type['L'] = 1;
    type['R'] = 1;


    for (int q = 0; q < t; q++) {
        int n, m;
        cin >> n >> m;
        vector <vector <char>> v(n, vector <char> (m));

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                cin >> v[i][j];
            }
        }

        string s;
        cin >> s;

        s = optimize(s);

        if (s.size() > 8) s.erase(4 + s.size() % 4);

        for (char direction : s) {
            simulate(v, direction);
        }

        output(v);
    }

    return 0;

}
/**
5 5
abc**
de***
fg***
h****
*****




1 5 5
aa...
.a.a.
.a.a.
aaaaa
.....
LURDLURDLURDLURDLURDLU













4
4 4
.a.b
..e.
....
.cd.
LRU
1 1
.
UULLRRDD
1 6
.a.aa.
LLURDDD
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR




*/
