#include <iostream>
using namespace std;

char** table;
char inst[106];
int instCnt = 0;
int n, m;

void simul(const char action) {
	int last = 0;
	if (action == 'U') {
		for (int i = 0; i < n; i++) {
			last = 0;
			for (int j = 0; j < m; j++) {
				if (table[j][i] != '.') {
					if (last != j) {
						table[last][i] = table[j][i];
						table[j][i] = '.';
					}
					last++;
				}
			}
		}
	}
	if (action == 'D') {
		for (int i = 0; i < n; i++) {
			last = m - 1;
			for (int j = m - 1; j >= 0; j--) {
				if (table[j][i] != '.') {
					if (last != j) {
						table[last][i] = table[j][i];
						table[j][i] = '.';
					}
					last--;
				}
			}
		}
	}
	if (action == 'L') {
		for (int i = 0; i < m; i++) {
			last = 0;
			for (int j = 0; j < n; j++) {
				if (table[i][j] != '.') {
					if (last != j) {
						table[i][last] = table[i][j];
						table[i][j] = '.';
					}
					last++;
				}
			}
		}
	}
	if (action == 'R') {
		for (int i = 0; i < m; i++) {
			last = n - 1;
			for (int j = n - 1; j >= 0; j--) {
				if (table[i][j] != '.') {
					if (last != j) {
						table[i][last] = table[i][j];
						table[i][j] = '.';
					}
					last--;
				}
			}
		}
	}
}

void getToCorner() {
	bool vert = 0, hor = 0;
	for (int i = 0; i < instCnt; i++) {
		if (i == instCnt - 1) {
			simul(inst[i]);
		}
		if (inst[i] == 'U' && inst[i + 1] != 'U' && inst[i + 1] != 'D') {
			simul(inst[i]);
			vert = 1;
		}
		if (inst[i] == 'D' && inst[i + 1] != 'U' && inst[i + 1] != 'D') {
			simul(inst[i]);
			vert = 1;
		}
		if (inst[i] == 'L' && inst[i + 1] != 'L' && inst[i + 1] != 'R') {
			simul(inst[i]);
			hor = 1;
		}
		if (inst[i] == 'R' && inst[i + 1] != 'L' && inst[i + 1] != 'R') {
			simul(inst[i]);
			hor = 1;
		}
		if (vert && hor) {
			return;
		}
	}
}

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	for (int c = 0; c < t; c++) {
		cin >> m >> n;
		table = new char*[m]();
		for (int i = 0; i < m; i++) {
			table[i] = new char[n]();
		}
		for (int i = 0; i < m; i++) {
			cin >> table[i];
		}
		cin >> inst;
		instCnt = 0;
		for (instCnt = 0; inst[instCnt]; instCnt++) {
			simul(inst[instCnt]);
		}
		for (int i = 0; i < m; i++) {
			cout << table[i] << "\n";
		}
		delete[] table;
	}
}
