#include <iostream>
using namespace std;

char** table;
char** tempTable;
char inst[1000001];
int instCnt = 0;
int n, m, l = -1, scndL = -1;
int minXPos = 100000000, maxXPos = 0, minYPos = 100000000, maxYPos = 0;
	int cornerIdx = 0;
/**
1
5 7
.ba.b..
ac..c.d
e......
....da.
d.eae..
DLDDRULRRR
*/
void simul(const char action, int stXPos = 0, int endXPos = n - 1, int stYPos = 0, int endYPos = m - 1) {
	int last = 0;
	if (action == 'U') {
		minYPos = stYPos;
		for (int i = stXPos; i <= endXPos; i++) {
			last = stYPos;
			for (int j = stYPos; j <= endYPos; j++) {
				if (table[j][i] != '.') {
					if (last != j) {
						table[last][i] = table[j][i];
						table[j][i] = '.';
					}
					last++;
				}
			}
			maxYPos = max(maxYPos, last - 1);
		}
	}
	if (action == 'D') {
		maxYPos = endYPos;
		for (int i = stXPos; i <= endXPos; i++) {
			last = endYPos;
			for (int j = endYPos; j >= stYPos; j--) {
				if (table[j][i] != '.') {
					if (last != j) {
						table[last][i] = table[j][i];
						table[j][i] = '.';
					}
					last--;
				}
			}
			minYPos = min(minYPos, last  + 1);
		}
	}
	if (action == 'L') {
		minXPos = stXPos;
		for (int i = stYPos; i <= endYPos; i++) {
			last = stXPos;
			for (int j = stXPos; j <= endXPos; j++) {
				if (table[i][j] != '.') {
					if (last != j) {
						table[i][last] = table[i][j];
						table[i][j] = '.';
					}
					last++;
				}
			}
			maxXPos = max(maxXPos, last - 1);
		}
	}
	if (action == 'R') {
		maxXPos = endXPos;
		for (int i = stYPos; i <= endYPos; i++) {
			last = endXPos;
			for (int j = endXPos; j >= stXPos; j--) {
				if (table[i][j] != '.') {
					if (last != j) {
						table[i][last] = table[i][j];
						table[i][j] = '.';
					}
					last--;
				}
			}
			minXPos = min(minXPos, last + 1);
		}
	}
}

int getToCorner() {
	bool vert = 0, hor = 0;
	bool up = 0, left = 0;
	for (int i = 0; i < instCnt; i++) {
		bool done = 0;
		if (i == instCnt - 1) {
			simul(inst[i]);
			continue;
		}
		if (inst[i] == 'U' && inst[i + 1] != 'U' && inst[i + 1] != 'D') {
			simul(inst[i]);
			vert = 1;
			up = 1;
			done = 1;
		}
		if (inst[i] == 'D' && inst[i + 1] != 'U' && inst[i + 1] != 'D') {
			simul(inst[i]);
			vert = 1;
			done = 1;
		}
		if (inst[i] == 'L' && inst[i + 1] != 'L' && inst[i + 1] != 'R') {
			simul(inst[i]);
			left = 1;
			hor = 1;
			done = 1;
		}
		if (inst[i] == 'R' && inst[i + 1] != 'L' && inst[i + 1] != 'R') {
			simul(inst[i]);
			hor = 1;
			done = 1;
		}
		if (done) {
			scndL = l;
			l = i;
		}
		if (vert && hor) {
			if (up && left) { cornerIdx = 0; }
			if (up && !left) { cornerIdx = 1; }
			if (!up && left) { cornerIdx = 2; }
			if (!up && !left) { cornerIdx = 3; }
			return i + 1;
		}
	}
	return instCnt;
}

void doRest(int stIdx) {
	for (int i = stIdx; i < instCnt; i++) {
//		cout << inst[i] << " " << cornerIdx << " - cornerIdx\n";
		if (i == instCnt - 1) {
			simul(inst[i], minXPos, maxXPos, minYPos, maxYPos);
			if (inst[i] == 'U') {cornerIdx -= 2;}
			if (inst[i] == 'D') {cornerIdx += 2;}
			if (inst[i] == 'L') {cornerIdx--;}
			if (inst[i] == 'R') {cornerIdx++;}
			continue;
		}
		if (scndL >= 0) {
			if (inst[i] == inst[scndL]) {
				continue;
			}
		}
		if (inst[i] == 'U' && inst[i + 1] != 'U') cornerIdx -= 2;
		if (inst[i] == 'D' && inst[i + 1] != 'D') cornerIdx += 2;
		if (inst[i] == 'L' && inst[i + 1] != 'L') cornerIdx--;
		if (inst[i] == 'R' && inst[i + 1] != 'R') cornerIdx++;

		bool done = 0;
		if (inst[i] == 'U' && inst[i + 1] != 'U' && inst[i + 1] != 'D') {
			simul(inst[i], minXPos, maxXPos, minYPos, maxYPos);
			done = 1;
		}
		if (inst[i] == 'D' && inst[i + 1] != 'U' && inst[i + 1] != 'D') {
			simul(inst[i], minXPos, maxXPos, minYPos, maxYPos);
			done = 1;
		}
		if (inst[i] == 'L' && inst[i + 1] != 'L' && inst[i + 1] != 'R') {
			simul(inst[i], minXPos, maxXPos, minYPos, maxYPos);
			done = 1;
		}
		if (inst[i] == 'R' && inst[i + 1] != 'L' && inst[i + 1] != 'R') {
			simul(inst[i], minXPos, maxXPos, minYPos, maxYPos);
			done = 1;
		}
		if (done) {
			scndL = l;
			l = i;
		}
	}
	///Translate to corner
	int cStX = (cornerIdx == 0 || cornerIdx == 2 ? 0 : n - 1 - (maxXPos - minXPos));
	int cStY = (cornerIdx == 0 || cornerIdx == 1 ? 0 : m - 1 - (maxYPos - minYPos));

	if (cStX == minXPos && cStY == minYPos) {
		return;
	}
	tempTable = new char*[maxYPos - minYPos + 1]();
	for (int i = 0; i <= maxYPos - minYPos; i++) {
		tempTable[i] = new char[maxXPos - minXPos + 1]();
		for (int j = 0; j <= maxXPos - minXPos; j++) {
			tempTable[i][j] = table[minYPos + i][minXPos + j];
			table[minYPos + i][minXPos + j] = '.';
		}
	}
	for (int i = 0; i <= maxYPos - minYPos; i++) {
		for (int j = 0; j <= maxXPos - minXPos; j++) {
			table[cStY + i][cStX + j] = tempTable[i][j];
		}
		delete[] tempTable[i];
	}
	delete[] tempTable;
}

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	for (int c = 0; c < t; c++) {
		cin >> m >> n;
		table = new char*[m]();
		for (int i = 0; i < m; i++) {
			table[i] = new char[n]();
		}
		for (int i = 0; i < m; i++) {
			cin >> table[i];
		}
		cin >> inst;
		instCnt = 0;
		for (instCnt = 0; inst[instCnt]; instCnt++) {}
		minXPos = 0;
		maxXPos = n - 1;
		minYPos = 0;
		maxYPos = m - 1;
		int nextStep = getToCorner();
//		cout << minXPos << ' ' << maxXPos << ' ' << minYPos << ' ' << maxYPos << '\n';
		if (maxXPos >= minXPos && maxYPos >= minYPos) {
			doRest(nextStep);
		}
		for (int i = 0; i < m; i++) {
			cout << table[i] << "\n";
			delete[] table[i];
		}
		delete[] table;
	}
}
