#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXN = 1e5 + 1;
llong Q;
llong N, M;
llong Light[MAXN];
vector<pair<int, int>> Graph[MAXN];
vector<pair<int, int>> Lighted_Edges;
vector<pair<int, int>> Edges;
vector<int> Lighted_Roots;
vector<pair<int, int>> Trying;
llong Visited[MAXN], Marker;
llong Answer;
llong On[MAXN];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> Q;
}

bool Check()
{
    for(auto& Edge : Lighted_Edges)
    {
        if(Light[Edge.first] != 1 && Light[Edge.second] != 1)
        {
            return false;
        }
    }

    for(auto& Edge : Edges)
    {
        if(Light[Edge.first] == 1 && Light[Edge.second] == 1)
        {
            return false;
        }
    }

    return true;
}

void Dfs(int U)
{
    if(Visited[U] == Marker)
    {
        return;
    }

    if(Light[U] != 1)
    {
        Answer += 2;
        Trying.push_back({U, 1});
        On[U] = Marker;
    }
    else
    {
        On[U] = Marker;
        Answer++;
        Trying.push_back({U, 1});
    }

    Visited[U] = Marker;

    for(auto& V : Graph[U])
    {
        if(V.second == 0)
        {
            if(On[V.first] == Marker)
            {
                Answer = -1e9;
                return;
            }

            continue;
        }

        Dfs(V.first);
    }

    if(Light[U] != 1)
    {
        Trying.push_back({U, 0});
        On[U] = Marker - 1;
    }
}

void Solve()
{
    Answer = 0;
    Marker++;

    for(auto& U : Lighted_Roots)
    {
        Dfs(U);

        if(Answer < 0)
        {
            cout << "NO" << '\n';
            return;
        }
    }

    cout << "YES" << '\n';
    cout << Answer << '\n';

    for(auto& U : Trying)
    {
        cout << U.first << " " << U.second << '\n';
    }
}

void Answer_Queries()
{
    while(Q--)
    {
        cin >> N >> M;

        for(int i = 0; i < M; i++)
        {
            int U, V, W;
            cin >> U >> V >> W;
            Graph[U].push_back({V, W});
            Graph[V].push_back({U, W});

            if(W == 1)
            {
                Lighted_Edges.push_back({U, V});
            }
            else
            {
                Edges.push_back({U, V});
            }
        }

        for(int i = 1; i <= N; i++)
        {
            cin >> Light[i];

            if(Light[i] == 1)
            {
                Lighted_Roots.push_back(i);
            }
        }

        if(!Check())
        {
            cout << "NO" << '\n';
        }
        else
        {
            Solve();
        }

        for(int i = 1; i <= N; i++)
        {
            if(!Graph[i].empty())
            {
                Graph[i].clear();
            }
        }

        if(!Lighted_Edges.empty()) Lighted_Edges.clear();
        if(!Lighted_Roots.empty()) Lighted_Roots.clear();
        if(!Edges.empty()) Edges.clear();
        if(!Trying.empty()) Trying.clear();
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Answer_Queries();
    return 0;
}

