#include <bits/stdc++.h>
#define llong long long
using namespace std;

const int MAXN = 1e5 + 1;
int Q;
int N, M;
int Light[MAXN];
vector<pair<int, int>> Graph[MAXN];
vector<pair<int, int>> Actions;
int Visited[MAXN], Marker;
int On[MAXN];
int Answer;
bool Error;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> Q;
}

void Dfs(int U)
{
    if(Visited[U] == Marker)
    {
        return;
    }

    if(Error)
    {
        return;
    }

    if(Light[U] != 1)
    {
        Answer += 2;
        Actions.push_back({U, 1});
    }
    else
    {
        Answer++;
        Actions.push_back({U, 1});
        On[U] = Marker;
    }

    Visited[U] = Marker;

    for(auto& V : Graph[U])
    {
        if(V.second == 0)
        {
            if(Light[U] == 1 && Light[V.first] == 1)
            {
                Error = true;
                return;
            }

            if(On[V.first] == Marker)
            {
                Error = true;
                return;
            }

            continue;
        }

        if(Light[U] == 0 && Light[V.first] == 0)
        {
            Error = true;
            return;
        }

        Dfs(V.first);
    }

    if(Light[U] != 1)
    {
        Actions.push_back({U, 0});
        On[U] = Marker - 1;
    }
}

void Answer_Queries()
{
    while(Q--)
    {
        cin >> N >> M;
        Error = false;
        vector<int> Normal;
        bool All = true;
        Marker++;

        for(int i = 0; i < M; i++)
        {
            int U, V, W;
            cin >> U >> V >> W;
            Graph[U].push_back({V, W});
            Graph[V].push_back({U, W});

            if(W == 0)
            {
                All = false;
            }
        }

        for(int i = 1; i <= N; i++)
        {
            cin >> Light[i];

            if(Light[i] == 0)
            {
                Normal.push_back(i);
            }
        }

        if(Normal.empty() && !All)
        {
            Error = true;
        }

        if(!Normal.empty())
        {
            for(auto& U : Normal)
            {
                Dfs(U);
            }
        }

        if(Error)
        {
            cout << "NO";
            cout << '\n';
        }
        else
        {
            cout << "YES" << '\n';
            cout << (int)Actions.size() << '\n';

            for(auto& U : Actions)
            {
                cout << U.first << " " << U.second << '\n';
            }
        }

        for(int i = 1; i <= N; i++)
        {
            if(!Graph[i].empty())
            {
                Graph[i].clear();
            }
        }

        Actions.clear();
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Answer_Queries();
    return 0;
}

