#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

int n, m, q;
vector < vector < char > > table;
vector < vector < char > > ans;
string queries;

void read()
{
    cin >> n >> m;
    table.resize(n + 1);
    ans.resize(n + 1);

    for(int i = 1; i <= n; i++)
    {
        table[i].resize(m + 1);
        ans[i].resize(m + 1);
        for(int j = 1; j <= m; j++)
        {
            cin >> table[i][j];
            ans[i][j] = table[i][j];
        }
    }
    
    cin >> queries;
    q = queries.size();
}

void clear_ans()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            ans[i][j] = '.';
        }
    }
}

void go_up()
{
    for(int j = 1; j <= m; j++)
    {
        int ptr = 1;
        for(int i = 1; i <= n; i++)
        {
            if('a' <= table[i][j] && table[i][j] <= 'z')
            {
                ans[ptr][j] = table[i][j];
                ptr++; 
            }
        }
    }
}

void go_down()
{
    for(int j = 1; j <= m; j++)
    {
        int ptr = n;
        for(int i = n; i >= 1; i--)
        {
            if('a' <= table[i][j] && table[i][j] <= 'z')
            {
                ans[ptr][j] = table[i][j];
                ptr--;
            }
        }
    }
}

void go_left()
{
    for(int i = 1; i <= n; i++)
    {
        int ptr = 1;
        for(int j = 1; j <= m; j++)
        {
            if('a' <= table[i][j] && table[i][j] <= 'z')
            {
                ans[i][ptr] = table[i][j];
                ptr++;
            }
        }
    }
}

void go_right()
{
    for(int i = 1; i <= n; i++)
    {
        int ptr = m;
        for(int j = m ; j >= 1; j--)
        {
            if('a' <= table[i][j] && table[i][j] <= 'z')
            {
                ans[i][ptr] = table[i][j];
                ptr--;
            }
        }
    }
}

void query(char dir)
{
    clear_ans();

    if(dir == 'L')
        go_left();
    else if(dir == 'R')
        go_right();
    else if(dir == 'D')
        go_down();
    else if(dir == 'U')
        go_up();

    table = ans;
}

void solve_lr()
{
    if(queries[q - 1] == 'L')
    {
        go_left();
    }
    else if(queries[q - 1] == 'R')
    {
        go_right();
    }
}

void print_ans()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cout << ans[i][j];
        }
        cout << endl;
    }
    cout << endl << endl;
}

void solve_simulate()
{
    for(int i = 0; i < q; i++)
    {
        // cout << "Before query : #" << i + 1 << endl;

        // print_ans();

        query(queries[i]);

        // cout << "After query : #" << i + 1 << endl;

        // print_ans();
    }
    ans = table;
}

void solve()
{
    bool lampa_lr = true;
    for(int i = 0; i < q; i++)
    {
        if(queries[i] != 'L' && queries[i] != 'R')
            lampa_lr = false;
    }

    if(lampa_lr)
        solve_lr();
    else
        solve_simulate();
}

void print()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cout << table[i][j];
        }
        cout << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;
    
    while(t--)
    {
        read();
        solve();
        print();    
    }
    return 0;
}
/**
 4 4
 .a.b
 ..e.
 ....
 .cd.
 LRU
 */