#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

int n, m, q;
vector < vector < char > > table;
string queries;

void read()
{
    cin >> n >> m;
    table.resize(n + 1);

    for(int i = 1; i <= n; i++)
    {
        table[i].resize(m + 1);
        for(int j = 1; j <= m; j++)
        {
            cin >> table[i][j];
        }
    }
    
    cin >> queries;
    q = queries.size();
}

bool check(int row, int col)
{
    return 'a' <= table[row][col] && table[row][col] <= 'z';
}

void go_up()
{
    for(int j = 1; j <= m; j++)
    {
        int ptr = 1;
        for(int i = 1; i <= n; i++)
        {
            if(check(i, j))
            {
                table[ptr][j] = table[i][j];
                if(i != ptr)
                {
                    table[i][j] = '.';
                }
                ptr++;
            }
        }
    }
}

void go_down()
{
    for(int j = 1; j <= m; j++)
    {
        int ptr = n;
        for(int i = n; i >= 1; i--)
        {
            if(check(i, j))
            {
                table[ptr][j] = table[i][j];
                if(i != ptr)
                {
                    table[i][j] = '.';
                }
                ptr--;
            }
        }
    }
}

void go_left()
{
    for(int i = 1; i <= n; i++)
        {
            int ptr = 1;
            for(int j = 1; j <= m; j++)
            {
                if(check(i, j))
                {
                    table[i][ptr] = table[i][j];

                    if(j != ptr)
                    {
                        table[i][j] = '.';
                    }
                    ptr++;
                }
            }
        }
}

void go_right()
{
    for(int i = 1; i <= n; i++)
        {
            int ptr = m;
            for(int j = m; j >= 1; j--)
            {
                if(check(i, j))
                {
                    table[i][ptr] = table[i][j];
                    if(j != ptr)
                    {
                        table[i][j] = '.';
                    }
                    ptr--;
                }
            }
        }
}

void query(char dir)
{
    if(dir == 'L')
        go_left();
    else if(dir == 'R')
        go_right();
    else if(dir == 'D')
        go_down();
    else if(dir == 'U')
        go_up();
}


void print_table()
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= m; j++)
        {
            cout << table[i][j];
        }
        cout << endl;
    }
}

void solve_lr()
{
    if(queries.back() == 'L')
    {
        go_left();
    }
    else
    {
        go_right();
    }
}

void solve_lru()
{
    int first_u = -1;
    int last_lr = q;
    for(int i = 0; i < q; i++)
    {
        if(queries[i] == 'U')
        {
            first_u = i;
            break;        
        }
    }

    for(int i = q - 1; i >= 0; i--)
    {
        if(queries[i] == 'L' || queries[i] == 'R')
        {
            last_lr = i;
            break;
        }
    }

    if(first_u == 0)
    {
        go_up();

        if(queries[last_lr] == 'L')
            go_left();
        else
            go_right();
    }
    else
    {
        char prev = queries[first_u - 1];

        if(queries[prev] == 'L')
            go_left();
        else 
            go_right();

        go_up();

        if(queries[last_lr] == 'L')
            go_left();
        else
            go_right();
    }
}

void solve_simulate()
{
    for(int i = 0; i < q; i++)
    {
        query(queries[i]);
    }
}

void solve()
{
    bool lampa_lr = true;
    bool lampa_lru = true;
    for(int i = 0; i < q; i++)
    {
        if(queries[i] != 'L' && queries[i] != 'R')
            lampa_lr = false;

        if(queries[i] == 'D')
            lampa_lru = false;
    }

    if(lampa_lr)
        solve_lr();
    // else if(lampa_lru)
    //     solve_lru();
    else
        solve_simulate();

    print_table();
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
    cin >> t;
    
    while(t--)
    {
        read();
        solve();
    }
    return 0;
}
/**
 4 4
 .a.b
 ..e.
 ....
 .cd.
 LRU
 */