#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 2e5 + 10;
const int MAXM = 2e5 + 10;

struct edge
{
    int u, v, col;
    edge()
    {
        u = v = 1;
        col = 0;
    }
    edge(int _u, int _v, int _col)
    {
        u = _u;
        v = _v;
        col = _col;
    }
};

int n, m;
edge edges[MAXM];
vector < int > adj[MAXN];
int visited[MAXN];
int c[MAXN];
vector < int > topo;
vector < pair < int, int > > ans;
bool nestava;
bool has_cycle;

void read()
{
    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        int u, v, col;
        cin >> u >> v >> col;

        edges[i] = edge(u, v, col);
    }
    for(int i = 1; i <= n; i++)
    {
        cin >> c[i];
        adj[i].clear();
    }
}

void make_graph()
{
    nestava = false;
    for(int i = 1; i <= m; i++)
    {
        int u = edges[i].u;
        int v = edges[i].v;
        int col = edges[i].col;

        if(c[u] == c[v] && c[u] != col)
        {
            nestava = true;
            return;
        }
        if(c[u] == col)
        {
            adj[v].push_back(u);
        }
        else
        {
            adj[u].push_back(v);
        }
    }
}

void dfs(int u)
{
    visited[u] = 1;
    for(int v : adj[u])
    {
        if(visited[v] == 0)
            dfs(v);
        else if(visited[v] == 1)
            has_cycle = true;
    }
    visited[u] = 2;
    topo.push_back(u);
}

void solve()
{
    has_cycle = false;
    topo.clear();
    ans.clear();

    memset(visited, 0, sizeof(visited));

    for(int i = 1; i <= n; i++)
    {
        if(visited[i] == 0)
            dfs(i);
    }

    reverse(topo.begin(), topo.end());

    for(int i = 1; i <= n; i++)
    {
        ans.push_back({i, !c[i]});
    }

    for(int u : topo)
    {
        ans.push_back({u, c[u]});
    }
}

void print()
{
    if(nestava || has_cycle)
    {
        cout << "NO" << endl;
        return;
    }

    cout << "YES" << endl;
    cout << ans.size() << endl;

    for(pair < int, int > change : ans)
    {
        cout << change.first << " " << change.second << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while(t--)
    {
        read();
        make_graph();
        solve();
        print();
    }

    return 0;
}
/*
5 
4 4
1 2 0
2 3 1
3 4 0
2 4 1
0 1 0 0
4 4
1 2 0
2 3 1
3 4 0
4 1 1
0 1 0 1
1 0
1
1 0
0
2 1
1 2 0
0 0
*/